/*
 * @file
 * FCK Content Injector Plugin.
 * Plugin to inject a template in the editor.
 *
 */

// Register the related command.
FCKCommands.RegisterCommand('FCK_Content_Injector', new FCKDialogCommand('FCK_Content_Injector', FCKLang.FCK_Content_InjectorDlgTitle, FCKPlugins.Items['fck_content_injector'].Path + 'fck_content_injector.html', 550, 450));

// Create the toolbar button.
var oTemplateToolbarButton = new FCKToolbarButton('FCK_Content_Injector', FCKLang.FCK_Content_InjectorBtn);
oTemplateToolbarButton.IconPath = FCKPlugins.Items['fck_content_injector'].Path + 'toolbaricon.gif';

FCKToolbarItems.RegisterItem('FCK_Content_Injector', oTemplateToolbarButton);

// The object used for all operations.
var FCK_Content_Injector = new Object();

// Add a new item at the actual selection.
FCK_Content_Injector.Add = function() {
  var oSpan = FCK.CreateElement('SPAN');
  var args=Array.prototype.slice.call(arguments);
  args.unshift(oSpan);
  this.SetupSpan.apply(this, args);
}

FCK_Content_Injector.SetupSpan = function() {
  var args=Array.prototype.slice.call(arguments);
  var span=args.shift();
  span.innerHTML = '[[TEMPLATE ' + args.join(',') + ' ]]';
  span.style.backgroundColor = '#CCFFCC';
  span.style.color = '#000000';

  if (FCKBrowserInfo.IsGecko) {
    span.style.cursor = 'default';
  }

  var d = new Date();
  span.id = 'TEMPLATE_' + parseInt(Math.random()*10000);
  span.contentEditable = false;

  // To avoid it to be resized.
  span.onresizestart = function() {
    FCK.EditorWindow.event.returnValue = false;
    return false;
  }
}

// On Gecko ensure the user select all the SPAN when clicking on it.
FCK_Content_Injector._SetupClickListener = function() {
  FCK_Content_Injector._ClickListener = function(e) {
    if (e.target.tagName == 'SPAN' && e.target.id.substr(0, 9) == 'TEMPLATE_') {
      FCKSelection.SelectNode(e.target);
    }
  }

  FCK.EditorDocument.addEventListener('click', FCK_Content_Injector._ClickListener, true);
}

// Open the dialog on double click.
FCK_Content_Injector.OnDoubleClick = function(span) {
  if (span.tagName == 'SPAN' && span.id.substr(0, 9) == 'TEMPLATE_') {
    FCKCommands.GetCommand('FCK_Content_Injector').Execute();
  }
}

// Check if a FCK_Content_Injector name is already in use.
FCK_Content_Injector.Exist = function(name) {
  return false;
}

if (FCKBrowserInfo.IsIE) {
  FCK_Content_Injector.Redraw = function() {
    if (FCK.EditMode != FCK_EDITMODE_WYSIWYG) {
      return;
    }

    var aElements = FCK.EditorDocument.body.innerText.match(/\[\[TEMPLATE[^\[\]]+\]\]/g);
    if (!aElements) {
      return;
    }

    var oRange = FCK.EditorDocument.body.createTextRange();

    for (var i = 0; i < aElements.length; i++) {
      if (oRange.findText(aElements[i])) {
        var d = new Date();
        oRange.pasteHTML('<span style="color: #000000; background-color: #CCFFCC" contenteditable="false" id="TEMPLATE_' + d.getMilliseconds() + '">' + aElements[i] + '</span>');
      }
    }
  }
}
else {
  FCK_Content_Injector.Redraw = function() {
    if (FCK.EditMode != FCK_EDITMODE_WYSIWYG) {
      return;
    }

    var oInteractor = FCK.EditorDocument.createTreeWalker(FCK.EditorDocument.body, NodeFilter.SHOW_TEXT, FCK_Content_Injector._AcceptNode, true);

    var	aNodes = new Array();

    while ((oNode = oInteractor.nextNode())) {
      aNodes[ aNodes.length ] = oNode;
    }

    for (var n = 0; n < aNodes.length; n++) {
      var aPieces = aNodes[n].nodeValue.split(/(\[\[TEMPLATE[^\[\]]+\]\])/g);

      for (var i = 0; i < aPieces.length; i++) {
        if (aPieces[i].length > 0) {
          if (aPieces[i].indexOf('[[TEMPLATE') == 0) {
            var sContent = aPieces[i].match(/\[\[TEMPLATE\s*([^\]]*?)\s*\]\]/)[1];
            var aParts = sContent.split(",");
            var oSpan = FCK.EditorDocument.createElement('span');
            aParts.unshift(oSpan);
            FCK_Content_Injector.SetupSpan.apply(FCK_Content_Injector, aParts);
            aNodes[n].parentNode.insertBefore(oSpan, aNodes[n]);
          }
          else {
            aNodes[n].parentNode.insertBefore(FCK.EditorDocument.createTextNode(aPieces[i]) , aNodes[n]);
          }
        }
      }
      aNodes[n].parentNode.removeChild(aNodes[n]);
    }
    FCK_Content_Injector._SetupClickListener();
  }

  FCK_Content_Injector._AcceptNode = function(node) {
    if (/\[\[TEMPLATE[^\[\]]+\]\]/.test(node.nodeValue)) {
      return NodeFilter.FILTER_ACCEPT;
    }
    else {
      return NodeFilter.FILTER_SKIP;
    }
  }
}

FCK.Events.AttachEvent('OnAfterSetHTML', FCK_Content_Injector.Redraw);

// Process the SPAN tags to replace with the resulting value of the item.
function templateFunc(node, htmlNode) {
  if (htmlNode.id.substr(0, 9) == 'TEMPLATE_') {
    node = FCKXHtml.XML.createTextNode(htmlNode.innerHTML);
  }
  return node;
}

var preTemplateFunc = FCKXHtml.TagProcessors['span'];

if (typeof FCKXHtml.TagProcessors['span'] != 'function') {
  FCKXHtml.TagProcessors['span'] = templateFunc;
}
else {
  FCKXHtml.TagProcessors['span'] = function(node, htmlNode) {
    node = preTemplateFunc(node, htmlNode);
    return templateFunc(node, htmlNode);
  }
}
